/*
 * @(#)TVshow.java
 *
 * Copyright (c) 1998 NAKAGAWA Masami
 *
 * Permission to use, copy, modify, and distribute this software
 * for NON-COMMERCIAL purpose and without fee is hereby granted.
 */

import java.applet.*;
import java.awt.*;
import java.util.*;
import java.net.*;

/** A class of TVshow applet
 * @author	NAKAGAWA Masami
 * @version	1.0, 1 Mar 1998
 */
public class TVshow extends Applet implements Runnable {
    Image image[];
    URL url[];
    String title[];
    String message[];
    Image bgImage;
    Thread thread;
    MediaTracker mt = new MediaTracker(this);
    Image offImage;
    Graphics offScreen;
    Dimension size;
    Color bgColor = Color.black;
    Color dispColor = Color.black;
    Color[] noiseColor = {Color.white, Color.lightGray, Color.gray, Color.darkGray};
    int noiseWidth = 2;
    int shake = 3;
    Frame frame;
    Rectangle area;
    boolean inTheArea = false;
    int channel = 1;
    Font titleFont;
    FontMetrics titleFM;
    FontMetrics messageFM;
    int current = 0;
    String target;
    boolean decided;
    int messageX;
    int messageSpeed = 4;
    Font messageFont;
    int shadowX = 4;
    int shadowY = 4;
    int auto;
    boolean autoMessage;
    long nextTime;
    boolean onAir;
    boolean noise;
    Color[] titleColor;
    Color[] messageColor;
    Color[] shadowColor;
    int titlePos;
    int messagePos;
    String imageDir = ".";
    String defaultImage;
    String defaultURL;
    String defaultTitle;
    String defaultMessage;
    Color defaultShadowColor = Color.black;
    Color defaultTitleColor = Color.white;
    Color defaultMessageColor = Color.white;


    public void init() {
        size = size();

        String s = getParameter("titleFont");
        if (s != null) {
            StringTokenizer st = new StringTokenizer(s, ",");
            int fs = Integer.parseInt(st.nextToken());
            if (fs <= 0) fs = 24;
            String fn = st.hasMoreTokens()?st.nextToken():"Helvetica";
            int ft = st.hasMoreTokens()?Integer.parseInt(st.nextToken()):Font.BOLD;
            titleFont = new Font(fn, ft, fs);
        } else {
            titleFont = new Font("Helvetica", Font.BOLD, 24);
        }
        titleFM = getFontMetrics(titleFont);

        s = getParameter("messageFont");
        if (s != null) {
            StringTokenizer st = new StringTokenizer(s, ",");
            int fs = Integer.parseInt(st.nextToken());
            if (fs <= 0) fs = 16;
            String fn = st.hasMoreTokens()?st.nextToken():"Helvetica";
            int ft = st.hasMoreTokens()?Integer.parseInt(st.nextToken()):Font.BOLD;
            messageFont = new Font(fn, ft, fs);
        } else {
            messageFont = new Font("Helvetica", Font.BOLD, 16);
        }
        messageFM = getFontMetrics(messageFont);

        s = getParameter("area");
        if (s != null) {
            StringTokenizer st = new StringTokenizer(s, ",");
            int x = Integer.parseInt(st.nextToken());
            int y = Integer.parseInt(st.nextToken());
            int w = Integer.parseInt(st.nextToken());
            int h = Integer.parseInt(st.nextToken());
            area = new Rectangle(x, y, w, h);
        } else {
            area = new Rectangle(0, 0, size.width, size.height);
        }
        s = getParameter("imageDir");
        if (s != null) {
            imageDir = s;
        }
        s = getParameter("bgImage");
        if (s != null) {
            bgImage = getImage(getDocumentBase(), imageDir + "/" + s);
            mt.addImage(bgImage, 0);
            mt.addImage(bgImage, 0, size.width, size.height);
        }
        s = getParameter("bgColor");
        if (s != null) {
            bgColor = new Color(Integer.parseInt(s, 16));
        }
        s = getParameter("noiseColor");
        if (s != null) {
            StringTokenizer st = new StringTokenizer(s, ",");
            noiseColor = new Color[st.countTokens()];
            for (int i = 0; i < noiseColor.length; i++) {
                noiseColor[i] = new Color(Integer.parseInt(st.nextToken(), 16));
            }
        }
        s = getParameter("noiseWidth");
        if (s != null) {
            noiseWidth = Integer.parseInt(s);
        }
        s = getParameter("shake");
        if (s != null) {
            shake = Integer.parseInt(s);
        }
        s = getParameter("target");
        if (s != null) {
            target = s;
        }
        s = getParameter("messageSpeed");
        if (s != null) {
            messageSpeed = Integer.parseInt(s);
        }
        s = getParameter("shadowX");
        if (s != null) {
            shadowX = Integer.parseInt(s);
        }
        s = getParameter("shadowY");
        if (s != null) {
            shadowY = Integer.parseInt(s);
        }
        s = getParameter("auto");
        if (s != null) {
            auto = Integer.parseInt(s);
            if (auto < 0) {
                auto = -auto;
                autoMessage = true;
            }
        }
        s = getParameter("noise");
        if (s != null) {
            noise = Boolean.valueOf(s).booleanValue();
        }
        s = getParameter("titlePos");
        if (s != null) {
            titlePos = Integer.parseInt(s);
        }
        s = getParameter("messagePos");
        if (s != null) {
            messagePos = Integer.parseInt(s);
        }
        s = getParameter("dispColor");
        if (s != null) {
            dispColor = new Color(Integer.parseInt(s, 16));
        }
        s = getParameter("channel");
        if (s != null) {
            channel = Integer.parseInt(s);
        }

        defaultImage = getParameter("image");
        defaultURL = getParameter("url");
        defaultTitle = getParameter("title");
        defaultMessage = getParameter("message");
        s = getParameter("titleColor");
        if (s != null) defaultTitleColor = new Color(Integer.parseInt(getParameter("titleColor"), 16));
        s = getParameter("shadowColor");
        if (s != null) defaultShadowColor = new Color(Integer.parseInt(getParameter("shadowColor"), 16));
        s = getParameter("messageColor");
        if (s != null) defaultMessageColor = new Color(Integer.parseInt(getParameter("messageColor"), 16));

        image = new Image[channel];
        url = new URL[channel];
        title = new String[channel];
        message = new String[channel];
        titleColor = new Color[channel];
        messageColor = new Color[channel];
        shadowColor = new Color[channel];
        for (int i = 0; i < channel; i++) {
            s = getParameter("image" + (i + 1));
            if (s == null) s = defaultImage;
            if (s != null) {
                image[i] = getImage(getDocumentBase(), imageDir + "/" + s);
                mt.addImage(image[i], i, area.width + shake, area.height + shake);
            }
            s = getParameter("url" + (i + 1));
            if (s == null) s = defaultURL;
            if (s != null) {
                try {
                    url[i] = new URL(s);
                } catch (MalformedURLException ex) {
                    try {
                        url[i] = new URL(getDocumentBase(), s);
                    } catch (MalformedURLException e) {
                        e.printStackTrace();
                    }
                }
            }
            s = getParameter("message" + (i + 1));
            if (s != null) message[i] = s;
            else message[i] = defaultMessage;
            s = getParameter("title" + (i + 1));
            if (s != null) title[i] = s;
            else title[i] = defaultTitle;
            s = getParameter("messageColor" + (i + 1));
            if (s != null) messageColor[i] = new Color(Integer.parseInt(s, 16));
            else messageColor[i] = defaultMessageColor;
            s = getParameter("titleColor" + (i + 1));
            if (s != null) titleColor[i] = new Color(Integer.parseInt(s, 16));
            else titleColor[i] = defaultTitleColor;
            s = getParameter("shadowColor" + (i + 1));
            if (s != null) shadowColor[i] = new Color(Integer.parseInt(s, 16));
            shadowColor[i] = defaultShadowColor;
        }

        offImage = createImage(size.width, size.height);
        Component comp = this;
        while (comp != null) {
            if ((comp = comp.getParent()) instanceof Frame) {
                frame = (Frame)comp;
                break;
            }
        }
    }
    
    public void start() {
        offScreen = offImage.getGraphics();
        inTheArea = false;
        decided = false;
        messageX = area.x + area.width;
        if (thread == null) {
            thread = new Thread(this);
            thread.start();
        }
    }
    
    public void stop() {
        frame.setCursor(Frame.DEFAULT_CURSOR);
        if (thread != null) {
            thread.stop();
            thread = null;
        }
    }
    
    public void paint(Graphics g) {
        if (offImage != null) {
            g.drawImage(offImage, 0, 0, null);
        }
    }
    
    public void update(Graphics g) {
        paint(g);
    }
    
    void drawMessage(String s) {
        offScreen.setColor(Color.black);
        offScreen.fillRect(0, 0, size.width, size.height);
        offScreen.setColor(Color.cyan);
        offScreen.setFont(messageFont);
        int x = (size.width - messageFM.stringWidth(s)) / 2;
        int y = (size.height - messageFM.getHeight()) / 2;
        offScreen.drawString(s, x, y);
        paint(getGraphics());
    }
    
    public void run() {
        drawMessage("Loading images...");
        try {
            mt.waitForID(0);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        mt.checkAll(true);
        offScreen.setColor(bgColor);
        offScreen.fillRect(0, 0, size.width, size.height);
        if (bgImage != null) {
            offScreen.drawImage(bgImage, 0, 0, size.width, size.height, null);
        }
        offScreen.setColor(dispColor);
        offScreen.fillRect(area.x, area.y, area.width, area.height);
        repaint();
        try {
            Thread.sleep(100);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        nextTime = System.currentTimeMillis() + 1000;
        offScreen.clipRect(area.x, area.y, area.width, area.height);
        while (true) {
            offScreen.setColor(dispColor);
            offScreen.fillRect(area.x, area.y, area.width, area.height);
            int dx = 0, dy = 0;
            if (onAir && image[current] != null) {
                dx = -(int)(Math.random() * (shake + 1));
                dy = -(int)(Math.random() * (shake + 1));
                offScreen.drawImage(image[current], area.x + dx, area.y + dy, area.width + shake, area.height + shake, null);
            }
            if (onAir && title[current] != null) {
                offScreen.setFont(titleFont);
                int x = area.x + (area.width - titleFM.stringWidth(title[current])) / 2;
                int y = area.y + (area.height + titleFM.getAscent()) / 2;
                offScreen.setColor(shadowColor[current]);
                offScreen.drawString(title[current], x + dx + shadowX, y + dy + shadowY + titlePos);
                offScreen.setColor(titleColor[current]);
                offScreen.drawString(title[current], x + dx, y + dy + titlePos);
            }
            if (onAir && message[current] != null) {
                offScreen.setFont(messageFont);
                int y = area.y + area.height - messageFM.getLeading() - messageFM.getDescent();
                offScreen.setColor(messageColor[current]);
                offScreen.drawString(message[current], messageX, y + messagePos);
                messageX -= messageSpeed;
                if (messageX + messageFM.stringWidth(message[current]) + 10 * messageSpeed < area.x) {
                    messageX = area.x + area.width;
                    if (autoMessage) {
                        onAir = false;
                        if (++current >= channel) current = 0;
                        nextTime = System.currentTimeMillis() + 1000;
                        System.out.println("DEFAULT");
                        frame.setCursor(Frame.DEFAULT_CURSOR);
                    }
                }
            }
            if (noiseWidth > 0 && (noise || !onAir)) {
                for (int y = 0; y < size.height; y += 2) {
                    offScreen.setColor(noiseColor[(int)(Math.random() * noiseColor.length)]);
                    int x = (int)(Math.random() * (area.width + noiseWidth)) - noiseWidth;
                    offScreen.drawLine(area.x + x, area.y + y, area.x + x + noiseWidth, area.y + y);
                }
            }
            repaint(area.x, area.y, area.width, area.height);
            
            if (auto > 0 && (!inTheArea || autoMessage) && nextTime < System.currentTimeMillis()) {
                if (onAir) {
                    if (!autoMessage || message[current] == null) {
                        if (++current >= channel) current = 0;
                        nextTime = System.currentTimeMillis() + 1000;
                        onAir = false;
                        System.out.println("DEFAULT");
                        frame.setCursor(Frame.DEFAULT_CURSOR);
                    }
                } else {
                    nextTime = System.currentTimeMillis() + 1000 * auto;
                    onAir = true;
                    if (url[current] != null && inTheArea) {
                        System.out.println("HAND");
                        frame.setCursor(Frame.HAND_CURSOR);
                    }
                }
            }
            try {
                Thread.sleep(50);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
    
    public boolean mouseMove(Event evt, int x, int y) {
        if (decided) return true;
        if (area.inside(x, y)) {
            if (!inTheArea) {
                inTheArea = true;
                if (url[current] != null) {
                    System.out.println("HAND");
                    frame.setCursor(Frame.HAND_CURSOR);
                }
                if (!autoMessage) {
                    onAir = true;
                }
            }
        } else {
            if (inTheArea) {
                inTheArea = false;
                System.out.println("DEFAULT");
                frame.setCursor(Frame.DEFAULT_CURSOR);
                if (!autoMessage) {
                    onAir = false;
                    nextTime = System.currentTimeMillis() + 1000;
                    if (++current >= channel) current = 0;
                }
            }
        }
        return true;
    }
    
    public boolean mouseEnter(Event evt, int x, int y) {
        if (decided) return true;
        if (area.inside(x, y)) {
            inTheArea = true;
            if (url[current] != null) {
                System.out.println("HAND");
                frame.setCursor(Frame.HAND_CURSOR);
            }
            if (!autoMessage) {
                onAir = true;
            }
        }
        return true;
    }
    
    public boolean mouseExit(Event evt, int x, int y) {
        if (decided) return true;
        if (inTheArea) {
            inTheArea = false;
            System.out.println("DEFAULT");
            frame.setCursor(Frame.DEFAULT_CURSOR);
            if (!autoMessage) {
                onAir = false;
                nextTime = System.currentTimeMillis() + 1000;
                if (++current >= channel) current = 0;
            }
        }
        return true;
    }
    
    public boolean mouseUp(Event evt, int x, int y) {
        if (area.inside(x, y) && onAir) {
            if (url[current] != null) {
                AppletContext ac = getAppletContext();
                if (target == null) {
                    ac.showDocument(url[current]);
                } else {
                    ac.showDocument(url[current], target);
                }
                decided = true;
            }
        }
        return true;
    }
}